// Copyright 2023, the Chromium project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

// Autogenerated from Pigeon (v9.2.4), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, unnecessary_import
// ignore_for_file: avoid_relative_lib_imports
import 'dart:async';
import 'dart:typed_data' show Float64List, Int32List, Int64List, Uint8List;
import 'package:flutter/foundation.dart' show ReadBuffer, WriteBuffer;
import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';

import 'package:firebase_auth_platform_interface/src/pigeon/messages.pigeon.dart';

class _TestFirebaseAuthHostApiCodec extends StandardMessageCodec {
  const _TestFirebaseAuthHostApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PigeonActionCodeInfo) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is PigeonActionCodeInfoData) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is PigeonActionCodeSettings) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is PigeonAdditionalUserInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is PigeonAuthCredential) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is PigeonFirebaseApp) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is PigeonFirebaseAuthSettings) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is PigeonIdTokenResult) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorInfo) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorSession) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is PigeonPhoneMultiFactorAssertion) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is PigeonSignInProvider) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserCredential) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserDetails) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserInfo) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserProfile) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is PigeonVerifyPhoneNumberRequest) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return PigeonActionCodeInfo.decode(readValue(buffer)!);
      case 129:
        return PigeonActionCodeInfoData.decode(readValue(buffer)!);
      case 130:
        return PigeonActionCodeSettings.decode(readValue(buffer)!);
      case 131:
        return PigeonAdditionalUserInfo.decode(readValue(buffer)!);
      case 132:
        return PigeonAuthCredential.decode(readValue(buffer)!);
      case 133:
        return PigeonFirebaseApp.decode(readValue(buffer)!);
      case 134:
        return PigeonFirebaseAuthSettings.decode(readValue(buffer)!);
      case 135:
        return PigeonIdTokenResult.decode(readValue(buffer)!);
      case 136:
        return PigeonMultiFactorInfo.decode(readValue(buffer)!);
      case 137:
        return PigeonMultiFactorSession.decode(readValue(buffer)!);
      case 138:
        return PigeonPhoneMultiFactorAssertion.decode(readValue(buffer)!);
      case 139:
        return PigeonSignInProvider.decode(readValue(buffer)!);
      case 140:
        return PigeonUserCredential.decode(readValue(buffer)!);
      case 141:
        return PigeonUserDetails.decode(readValue(buffer)!);
      case 142:
        return PigeonUserInfo.decode(readValue(buffer)!);
      case 143:
        return PigeonUserProfile.decode(readValue(buffer)!);
      case 144:
        return PigeonVerifyPhoneNumberRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class TestFirebaseAuthHostApi {
  static TestDefaultBinaryMessengerBinding? get _testBinaryMessengerBinding =>
      TestDefaultBinaryMessengerBinding.instance;
  static const MessageCodec<Object?> codec = _TestFirebaseAuthHostApiCodec();

  Future<String> registerIdTokenListener(PigeonFirebaseApp app);

  Future<String> registerAuthStateListener(PigeonFirebaseApp app);

  Future<void> useEmulator(PigeonFirebaseApp app, String host, int port);

  Future<void> applyActionCode(PigeonFirebaseApp app, String code);

  Future<PigeonActionCodeInfo> checkActionCode(
      PigeonFirebaseApp app, String code);

  Future<void> confirmPasswordReset(
      PigeonFirebaseApp app, String code, String newPassword);

  Future<PigeonUserCredential> createUserWithEmailAndPassword(
      PigeonFirebaseApp app, String email, String password);

  Future<PigeonUserCredential> signInAnonymously(PigeonFirebaseApp app);

  Future<PigeonUserCredential> signInWithCredential(
      PigeonFirebaseApp app, Map<String?, Object?> input);

  Future<PigeonUserCredential> signInWithCustomToken(
      PigeonFirebaseApp app, String token);

  Future<PigeonUserCredential> signInWithEmailAndPassword(
      PigeonFirebaseApp app, String email, String password);

  Future<PigeonUserCredential> signInWithEmailLink(
      PigeonFirebaseApp app, String email, String emailLink);

  Future<PigeonUserCredential> signInWithProvider(
      PigeonFirebaseApp app, PigeonSignInProvider signInProvider);

  Future<void> signOut(PigeonFirebaseApp app);

  Future<List<String?>> fetchSignInMethodsForEmail(
      PigeonFirebaseApp app, String email);

  Future<void> sendPasswordResetEmail(PigeonFirebaseApp app, String email,
      PigeonActionCodeSettings? actionCodeSettings);

  Future<void> sendSignInLinkToEmail(PigeonFirebaseApp app, String email,
      PigeonActionCodeSettings actionCodeSettings);

  Future<String> setLanguageCode(PigeonFirebaseApp app, String? languageCode);

  Future<void> setSettings(
      PigeonFirebaseApp app, PigeonFirebaseAuthSettings settings);

  Future<String> verifyPasswordResetCode(PigeonFirebaseApp app, String code);

  Future<String> verifyPhoneNumber(
      PigeonFirebaseApp app, PigeonVerifyPhoneNumberRequest request);

  static void setup(TestFirebaseAuthHostApi? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.registerIdTokenListener',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.registerIdTokenListener was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.registerIdTokenListener was null, expected non-null PigeonFirebaseApp.');
          final String output = await api.registerIdTokenListener(arg_app!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.registerAuthStateListener',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.registerAuthStateListener was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.registerAuthStateListener was null, expected non-null PigeonFirebaseApp.');
          final String output = await api.registerAuthStateListener(arg_app!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.useEmulator', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.useEmulator was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.useEmulator was null, expected non-null PigeonFirebaseApp.');
          final String? arg_host = (args[1] as String?);
          assert(arg_host != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.useEmulator was null, expected non-null String.');
          final int? arg_port = (args[2] as int?);
          assert(arg_port != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.useEmulator was null, expected non-null int.');
          await api.useEmulator(arg_app!, arg_host!, arg_port!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.applyActionCode', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.applyActionCode was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.applyActionCode was null, expected non-null PigeonFirebaseApp.');
          final String? arg_code = (args[1] as String?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.applyActionCode was null, expected non-null String.');
          await api.applyActionCode(arg_app!, arg_code!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.checkActionCode', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.checkActionCode was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.checkActionCode was null, expected non-null PigeonFirebaseApp.');
          final String? arg_code = (args[1] as String?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.checkActionCode was null, expected non-null String.');
          final PigeonActionCodeInfo output =
              await api.checkActionCode(arg_app!, arg_code!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.confirmPasswordReset', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.confirmPasswordReset was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.confirmPasswordReset was null, expected non-null PigeonFirebaseApp.');
          final String? arg_code = (args[1] as String?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.confirmPasswordReset was null, expected non-null String.');
          final String? arg_newPassword = (args[2] as String?);
          assert(arg_newPassword != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.confirmPasswordReset was null, expected non-null String.');
          await api.confirmPasswordReset(arg_app!, arg_code!, arg_newPassword!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.createUserWithEmailAndPassword',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.createUserWithEmailAndPassword was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.createUserWithEmailAndPassword was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.createUserWithEmailAndPassword was null, expected non-null String.');
          final String? arg_password = (args[2] as String?);
          assert(arg_password != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.createUserWithEmailAndPassword was null, expected non-null String.');
          final PigeonUserCredential output =
              await api.createUserWithEmailAndPassword(
                  arg_app!, arg_email!, arg_password!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInAnonymously', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInAnonymously was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInAnonymously was null, expected non-null PigeonFirebaseApp.');
          final PigeonUserCredential output =
              await api.signInAnonymously(arg_app!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCredential', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCredential was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCredential was null, expected non-null PigeonFirebaseApp.');
          final Map<String?, Object?>? arg_input =
              (args[1] as Map<Object?, Object?>?)?.cast<String?, Object?>();
          assert(arg_input != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCredential was null, expected non-null Map<String?, Object?>.');
          final PigeonUserCredential output =
              await api.signInWithCredential(arg_app!, arg_input!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCustomToken', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCustomToken was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCustomToken was null, expected non-null PigeonFirebaseApp.');
          final String? arg_token = (args[1] as String?);
          assert(arg_token != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithCustomToken was null, expected non-null String.');
          final PigeonUserCredential output =
              await api.signInWithCustomToken(arg_app!, arg_token!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailAndPassword',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailAndPassword was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailAndPassword was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailAndPassword was null, expected non-null String.');
          final String? arg_password = (args[2] as String?);
          assert(arg_password != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailAndPassword was null, expected non-null String.');
          final PigeonUserCredential output = await api
              .signInWithEmailAndPassword(arg_app!, arg_email!, arg_password!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailLink', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailLink was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailLink was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailLink was null, expected non-null String.');
          final String? arg_emailLink = (args[2] as String?);
          assert(arg_emailLink != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithEmailLink was null, expected non-null String.');
          final PigeonUserCredential output = await api.signInWithEmailLink(
              arg_app!, arg_email!, arg_emailLink!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signInWithProvider', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithProvider was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithProvider was null, expected non-null PigeonFirebaseApp.');
          final PigeonSignInProvider? arg_signInProvider =
              (args[1] as PigeonSignInProvider?);
          assert(arg_signInProvider != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signInWithProvider was null, expected non-null PigeonSignInProvider.');
          final PigeonUserCredential output =
              await api.signInWithProvider(arg_app!, arg_signInProvider!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.signOut', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signOut was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.signOut was null, expected non-null PigeonFirebaseApp.');
          await api.signOut(arg_app!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.fetchSignInMethodsForEmail',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.fetchSignInMethodsForEmail was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.fetchSignInMethodsForEmail was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.fetchSignInMethodsForEmail was null, expected non-null String.');
          final List<String?> output =
              await api.fetchSignInMethodsForEmail(arg_app!, arg_email!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.sendPasswordResetEmail',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendPasswordResetEmail was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendPasswordResetEmail was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendPasswordResetEmail was null, expected non-null String.');
          final PigeonActionCodeSettings? arg_actionCodeSettings =
              (args[2] as PigeonActionCodeSettings?);
          await api.sendPasswordResetEmail(
              arg_app!, arg_email!, arg_actionCodeSettings);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.sendSignInLinkToEmail', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendSignInLinkToEmail was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendSignInLinkToEmail was null, expected non-null PigeonFirebaseApp.');
          final String? arg_email = (args[1] as String?);
          assert(arg_email != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendSignInLinkToEmail was null, expected non-null String.');
          final PigeonActionCodeSettings? arg_actionCodeSettings =
              (args[2] as PigeonActionCodeSettings?);
          assert(arg_actionCodeSettings != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.sendSignInLinkToEmail was null, expected non-null PigeonActionCodeSettings.');
          await api.sendSignInLinkToEmail(
              arg_app!, arg_email!, arg_actionCodeSettings!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.setLanguageCode', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.setLanguageCode was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.setLanguageCode was null, expected non-null PigeonFirebaseApp.');
          final String? arg_languageCode = (args[1] as String?);
          final String output =
              await api.setLanguageCode(arg_app!, arg_languageCode);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.setSettings', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.setSettings was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.setSettings was null, expected non-null PigeonFirebaseApp.');
          final PigeonFirebaseAuthSettings? arg_settings =
              (args[1] as PigeonFirebaseAuthSettings?);
          assert(arg_settings != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.setSettings was null, expected non-null PigeonFirebaseAuthSettings.');
          await api.setSettings(arg_app!, arg_settings!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.verifyPasswordResetCode',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPasswordResetCode was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPasswordResetCode was null, expected non-null PigeonFirebaseApp.');
          final String? arg_code = (args[1] as String?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPasswordResetCode was null, expected non-null String.');
          final String output =
              await api.verifyPasswordResetCode(arg_app!, arg_code!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthHostApi.verifyPhoneNumber', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPhoneNumber was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPhoneNumber was null, expected non-null PigeonFirebaseApp.');
          final PigeonVerifyPhoneNumberRequest? arg_request =
              (args[1] as PigeonVerifyPhoneNumberRequest?);
          assert(arg_request != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthHostApi.verifyPhoneNumber was null, expected non-null PigeonVerifyPhoneNumberRequest.');
          final String output =
              await api.verifyPhoneNumber(arg_app!, arg_request!);
          return <Object?>[output];
        });
      }
    }
  }
}

class _TestFirebaseAuthUserHostApiCodec extends StandardMessageCodec {
  const _TestFirebaseAuthUserHostApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PigeonActionCodeInfo) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is PigeonActionCodeInfoData) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is PigeonActionCodeSettings) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is PigeonAdditionalUserInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is PigeonAuthCredential) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is PigeonFirebaseApp) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is PigeonFirebaseAuthSettings) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is PigeonIdTokenResult) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorInfo) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorSession) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is PigeonPhoneMultiFactorAssertion) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is PigeonSignInProvider) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserCredential) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserDetails) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserInfo) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserProfile) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is PigeonVerifyPhoneNumberRequest) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return PigeonActionCodeInfo.decode(readValue(buffer)!);
      case 129:
        return PigeonActionCodeInfoData.decode(readValue(buffer)!);
      case 130:
        return PigeonActionCodeSettings.decode(readValue(buffer)!);
      case 131:
        return PigeonAdditionalUserInfo.decode(readValue(buffer)!);
      case 132:
        return PigeonAuthCredential.decode(readValue(buffer)!);
      case 133:
        return PigeonFirebaseApp.decode(readValue(buffer)!);
      case 134:
        return PigeonFirebaseAuthSettings.decode(readValue(buffer)!);
      case 135:
        return PigeonIdTokenResult.decode(readValue(buffer)!);
      case 136:
        return PigeonMultiFactorInfo.decode(readValue(buffer)!);
      case 137:
        return PigeonMultiFactorSession.decode(readValue(buffer)!);
      case 138:
        return PigeonPhoneMultiFactorAssertion.decode(readValue(buffer)!);
      case 139:
        return PigeonSignInProvider.decode(readValue(buffer)!);
      case 140:
        return PigeonUserCredential.decode(readValue(buffer)!);
      case 141:
        return PigeonUserDetails.decode(readValue(buffer)!);
      case 142:
        return PigeonUserInfo.decode(readValue(buffer)!);
      case 143:
        return PigeonUserProfile.decode(readValue(buffer)!);
      case 144:
        return PigeonVerifyPhoneNumberRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class TestFirebaseAuthUserHostApi {
  static TestDefaultBinaryMessengerBinding? get _testBinaryMessengerBinding =>
      TestDefaultBinaryMessengerBinding.instance;
  static const MessageCodec<Object?> codec =
      _TestFirebaseAuthUserHostApiCodec();

  Future<void> delete(PigeonFirebaseApp app);

  Future<PigeonIdTokenResult> getIdToken(
      PigeonFirebaseApp app, bool forceRefresh);

  Future<PigeonUserCredential> linkWithCredential(
      PigeonFirebaseApp app, Map<String?, Object?> input);

  Future<PigeonUserCredential> linkWithProvider(
      PigeonFirebaseApp app, PigeonSignInProvider signInProvider);

  Future<PigeonUserCredential> reauthenticateWithCredential(
      PigeonFirebaseApp app, Map<String?, Object?> input);

  Future<PigeonUserCredential> reauthenticateWithProvider(
      PigeonFirebaseApp app, PigeonSignInProvider signInProvider);

  Future<PigeonUserDetails> reload(PigeonFirebaseApp app);

  Future<void> sendEmailVerification(
      PigeonFirebaseApp app, PigeonActionCodeSettings? actionCodeSettings);

  Future<PigeonUserCredential> unlink(PigeonFirebaseApp app, String providerId);

  Future<PigeonUserDetails> updateEmail(PigeonFirebaseApp app, String newEmail);

  Future<PigeonUserDetails> updatePassword(
      PigeonFirebaseApp app, String newPassword);

  Future<PigeonUserDetails> updatePhoneNumber(
      PigeonFirebaseApp app, Map<String?, Object?> input);

  Future<PigeonUserDetails> updateProfile(
      PigeonFirebaseApp app, PigeonUserProfile profile);

  Future<void> verifyBeforeUpdateEmail(PigeonFirebaseApp app, String newEmail,
      PigeonActionCodeSettings? actionCodeSettings);

  static void setup(TestFirebaseAuthUserHostApi? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.delete', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.delete was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.delete was null, expected non-null PigeonFirebaseApp.');
          await api.delete(arg_app!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.getIdToken', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.getIdToken was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.getIdToken was null, expected non-null PigeonFirebaseApp.');
          final bool? arg_forceRefresh = (args[1] as bool?);
          assert(arg_forceRefresh != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.getIdToken was null, expected non-null bool.');
          final PigeonIdTokenResult output =
              await api.getIdToken(arg_app!, arg_forceRefresh!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithCredential',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithCredential was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithCredential was null, expected non-null PigeonFirebaseApp.');
          final Map<String?, Object?>? arg_input =
              (args[1] as Map<Object?, Object?>?)?.cast<String?, Object?>();
          assert(arg_input != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithCredential was null, expected non-null Map<String?, Object?>.');
          final PigeonUserCredential output =
              await api.linkWithCredential(arg_app!, arg_input!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithProvider', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithProvider was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithProvider was null, expected non-null PigeonFirebaseApp.');
          final PigeonSignInProvider? arg_signInProvider =
              (args[1] as PigeonSignInProvider?);
          assert(arg_signInProvider != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.linkWithProvider was null, expected non-null PigeonSignInProvider.');
          final PigeonUserCredential output =
              await api.linkWithProvider(arg_app!, arg_signInProvider!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithCredential',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithCredential was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithCredential was null, expected non-null PigeonFirebaseApp.');
          final Map<String?, Object?>? arg_input =
              (args[1] as Map<Object?, Object?>?)?.cast<String?, Object?>();
          assert(arg_input != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithCredential was null, expected non-null Map<String?, Object?>.');
          final PigeonUserCredential output =
              await api.reauthenticateWithCredential(arg_app!, arg_input!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithProvider',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithProvider was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithProvider was null, expected non-null PigeonFirebaseApp.');
          final PigeonSignInProvider? arg_signInProvider =
              (args[1] as PigeonSignInProvider?);
          assert(arg_signInProvider != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reauthenticateWithProvider was null, expected non-null PigeonSignInProvider.');
          final PigeonUserCredential output = await api
              .reauthenticateWithProvider(arg_app!, arg_signInProvider!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.reload', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reload was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.reload was null, expected non-null PigeonFirebaseApp.');
          final PigeonUserDetails output = await api.reload(arg_app!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.sendEmailVerification',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.sendEmailVerification was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.sendEmailVerification was null, expected non-null PigeonFirebaseApp.');
          final PigeonActionCodeSettings? arg_actionCodeSettings =
              (args[1] as PigeonActionCodeSettings?);
          await api.sendEmailVerification(arg_app!, arg_actionCodeSettings);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.unlink', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.unlink was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.unlink was null, expected non-null PigeonFirebaseApp.');
          final String? arg_providerId = (args[1] as String?);
          assert(arg_providerId != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.unlink was null, expected non-null String.');
          final PigeonUserCredential output =
              await api.unlink(arg_app!, arg_providerId!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.updateEmail', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateEmail was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateEmail was null, expected non-null PigeonFirebaseApp.');
          final String? arg_newEmail = (args[1] as String?);
          assert(arg_newEmail != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateEmail was null, expected non-null String.');
          final PigeonUserDetails output =
              await api.updateEmail(arg_app!, arg_newEmail!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePassword', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePassword was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePassword was null, expected non-null PigeonFirebaseApp.');
          final String? arg_newPassword = (args[1] as String?);
          assert(arg_newPassword != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePassword was null, expected non-null String.');
          final PigeonUserDetails output =
              await api.updatePassword(arg_app!, arg_newPassword!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePhoneNumber', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePhoneNumber was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePhoneNumber was null, expected non-null PigeonFirebaseApp.');
          final Map<String?, Object?>? arg_input =
              (args[1] as Map<Object?, Object?>?)?.cast<String?, Object?>();
          assert(arg_input != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updatePhoneNumber was null, expected non-null Map<String?, Object?>.');
          final PigeonUserDetails output =
              await api.updatePhoneNumber(arg_app!, arg_input!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.updateProfile', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateProfile was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateProfile was null, expected non-null PigeonFirebaseApp.');
          final PigeonUserProfile? arg_profile =
              (args[1] as PigeonUserProfile?);
          assert(arg_profile != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.updateProfile was null, expected non-null PigeonUserProfile.');
          final PigeonUserDetails output =
              await api.updateProfile(arg_app!, arg_profile!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.FirebaseAuthUserHostApi.verifyBeforeUpdateEmail',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.verifyBeforeUpdateEmail was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.verifyBeforeUpdateEmail was null, expected non-null PigeonFirebaseApp.');
          final String? arg_newEmail = (args[1] as String?);
          assert(arg_newEmail != null,
              'Argument for dev.flutter.pigeon.FirebaseAuthUserHostApi.verifyBeforeUpdateEmail was null, expected non-null String.');
          final PigeonActionCodeSettings? arg_actionCodeSettings =
              (args[2] as PigeonActionCodeSettings?);
          await api.verifyBeforeUpdateEmail(
              arg_app!, arg_newEmail!, arg_actionCodeSettings);
          return <Object?>[];
        });
      }
    }
  }
}

class _TestMultiFactorUserHostApiCodec extends StandardMessageCodec {
  const _TestMultiFactorUserHostApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PigeonFirebaseApp) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorInfo) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is PigeonMultiFactorSession) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is PigeonPhoneMultiFactorAssertion) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return PigeonFirebaseApp.decode(readValue(buffer)!);
      case 129:
        return PigeonMultiFactorInfo.decode(readValue(buffer)!);
      case 130:
        return PigeonMultiFactorSession.decode(readValue(buffer)!);
      case 131:
        return PigeonPhoneMultiFactorAssertion.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class TestMultiFactorUserHostApi {
  static TestDefaultBinaryMessengerBinding? get _testBinaryMessengerBinding =>
      TestDefaultBinaryMessengerBinding.instance;
  static const MessageCodec<Object?> codec = _TestMultiFactorUserHostApiCodec();

  Future<void> enrollPhone(PigeonFirebaseApp app,
      PigeonPhoneMultiFactorAssertion assertion, String? displayName);

  Future<PigeonMultiFactorSession> getSession(PigeonFirebaseApp app);

  Future<void> unenroll(PigeonFirebaseApp app, String factorUid);

  Future<List<PigeonMultiFactorInfo?>> getEnrolledFactors(
      PigeonFirebaseApp app);

  static void setup(TestMultiFactorUserHostApi? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MultiFactorUserHostApi.enrollPhone', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.enrollPhone was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.enrollPhone was null, expected non-null PigeonFirebaseApp.');
          final PigeonPhoneMultiFactorAssertion? arg_assertion =
              (args[1] as PigeonPhoneMultiFactorAssertion?);
          assert(arg_assertion != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.enrollPhone was null, expected non-null PigeonPhoneMultiFactorAssertion.');
          final String? arg_displayName = (args[2] as String?);
          await api.enrollPhone(arg_app!, arg_assertion!, arg_displayName);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MultiFactorUserHostApi.getSession', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.getSession was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.getSession was null, expected non-null PigeonFirebaseApp.');
          final PigeonMultiFactorSession output =
              await api.getSession(arg_app!);
          return <Object?>[output];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MultiFactorUserHostApi.unenroll', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.unenroll was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.unenroll was null, expected non-null PigeonFirebaseApp.');
          final String? arg_factorUid = (args[1] as String?);
          assert(arg_factorUid != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.unenroll was null, expected non-null String.');
          await api.unenroll(arg_app!, arg_factorUid!);
          return <Object?>[];
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MultiFactorUserHostApi.getEnrolledFactors', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.getEnrolledFactors was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PigeonFirebaseApp? arg_app = (args[0] as PigeonFirebaseApp?);
          assert(arg_app != null,
              'Argument for dev.flutter.pigeon.MultiFactorUserHostApi.getEnrolledFactors was null, expected non-null PigeonFirebaseApp.');
          final List<PigeonMultiFactorInfo?> output =
              await api.getEnrolledFactors(arg_app!);
          return <Object?>[output];
        });
      }
    }
  }
}

class _TestMultiFactoResolverHostApiCodec extends StandardMessageCodec {
  const _TestMultiFactoResolverHostApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PigeonAdditionalUserInfo) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is PigeonAuthCredential) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is PigeonPhoneMultiFactorAssertion) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserCredential) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserDetails) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is PigeonUserInfo) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return PigeonAdditionalUserInfo.decode(readValue(buffer)!);
      case 129:
        return PigeonAuthCredential.decode(readValue(buffer)!);
      case 130:
        return PigeonPhoneMultiFactorAssertion.decode(readValue(buffer)!);
      case 131:
        return PigeonUserCredential.decode(readValue(buffer)!);
      case 132:
        return PigeonUserDetails.decode(readValue(buffer)!);
      case 133:
        return PigeonUserInfo.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class TestMultiFactoResolverHostApi {
  static TestDefaultBinaryMessengerBinding? get _testBinaryMessengerBinding =>
      TestDefaultBinaryMessengerBinding.instance;
  static const MessageCodec<Object?> codec =
      _TestMultiFactoResolverHostApiCodec();

  Future<PigeonUserCredential> resolveSignIn(
      String resolverId, PigeonPhoneMultiFactorAssertion assertion);

  static void setup(TestMultiFactoResolverHostApi? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MultiFactoResolverHostApi.resolveSignIn', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel, null);
      } else {
        _testBinaryMessengerBinding!.defaultBinaryMessenger
            .setMockDecodedMessageHandler<Object?>(channel,
                (Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.MultiFactoResolverHostApi.resolveSignIn was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_resolverId = (args[0] as String?);
          assert(arg_resolverId != null,
              'Argument for dev.flutter.pigeon.MultiFactoResolverHostApi.resolveSignIn was null, expected non-null String.');
          final PigeonPhoneMultiFactorAssertion? arg_assertion =
              (args[1] as PigeonPhoneMultiFactorAssertion?);
          assert(arg_assertion != null,
              'Argument for dev.flutter.pigeon.MultiFactoResolverHostApi.resolveSignIn was null, expected non-null PigeonPhoneMultiFactorAssertion.');
          final PigeonUserCredential output =
              await api.resolveSignIn(arg_resolverId!, arg_assertion!);
          return <Object?>[output];
        });
      }
    }
  }
}
